<template>
  <zt-dialog ref="dialog" column="2" @confirm="formSubmit" :stepMarker="stepMarker" :append-to-body="true">
    <el-form :model="dataForm" :inline="true" ref="dataForm" style="padding-top: 0" :disabled="dataForm.disabled"
             label-width="120px" class="testCheckFormAuto">
      <div>
        <el-form-item label-width="60px" label="编号:" style="width:100%;margin-bottom: -5px">
          <span>{{ dataForm.checkOrder.code || '编号自动生成' }}</span>
        </el-form-item>
      </div>
      <div style="border: 1px solid rgba(0,0,0,.2);width: 99%">
        <div style="border-bottom: 1px solid rgba(0,0,0,.2);" class="testCheckContentWidth">
          <el-form-item class="marginTopAndMarginBottom" label="项目标识" style="width: 49%">
            <el-input v-model="dataForm.project.softwareIdentity" placeholder="项目标识"></el-input>
          </el-form-item>
          <el-form-item class="marginTopAndMarginBottom" label="项目名称" style="width: 49%">
            <el-input v-model="dataForm.project.softwareName" placeholder="项目名称"></el-input>
          </el-form-item>
          <el-form-item class="marginTopAndMarginBottom3" label="检查人" style="width: 49%">
            <el-input v-if="stepMarker=='csjcd_first'" v-model="dataForm.checkOrder.examiner"
                      placeholder="检查人"></el-input>
            <span v-else>{{ dataForm.checkOrder.examiner }}</span>
          </el-form-item>
          <el-form-item class="marginTopAndMarginBottom3" label="检查时间" style="width: 49%">
            <el-date-picker
              v-if="stepMarker=='csjcd_first'"
              v-model="dataForm.checkOrder.examDate"
              type="date"
              placeholder="请选择检查时间">
            </el-date-picker>
            <span v-else>{{ dataForm.checkOrder.examDate }}</span>
          </el-form-item>
        </div>
        <div style="border-bottom: 1px solid rgba(0,0,0,.2);">
          <div style="padding-left:5px;padding-right:5px;">
            <div style="padding: 5px">检查项目:{{ subtitle }}</div>
            <div class="table-container">
              <el-table ref="tableCirculatOrderList" class="el-software el-margin-top-bot" border
                        :data="dataForm.checkOrderList"
                        stripe>
                <el-table-column prop="no" align="center" width="60" label="序号">
                  <template slot-scope="scope">
                    <span v-html="indexFormat(scope.$index)"></span>
                  </template>
                </el-table-column>
                <el-table-column prop="checkContent" min-width="180" label="主要检查内容">
                  <!--                  <template v-slot="{ row }">-->
                  <!--                    <el-input v-model="row.checkContent" placeholder="主要检查内容"></el-input>-->
                  <!--                  </template>-->
                </el-table-column>
                <el-table-column prop="checkResult" align="center" width="200" label="检查结果">
                  <template v-slot="{ row }">
                    <zt-dict :disabled="stepMarker!=='csjcd_first'" v-model="row.checkResult" :dict="getDict"
                             :radio="true"></zt-dict>
                  </template>
                </el-table-column>
                <el-table-column prop="remark" label="备注" width="100" align="center">
                  <template v-slot="{ row }">
                    <el-input v-if="stepMarker=='csjcd_first'" v-model="row.remark" placeholder="备注"></el-input>
                    <span v-else>{{ row.remark }}</span>
                  </template>
                </el-table-column>
                <!--                <el-table-column fixed="right" prop="files" label="上传附件" width="300" align="center">
                                  <template v-slot="{ row }">
                                    &lt;!&ndash;                    <zt-table-button @click="files(row.id)">上传附件</zt-table-button>&ndash;&gt;
                                    <table-uploader busi-type="circulat_order" model-name="row" :dataForm="row"
                                                    v-model="row.files"/>
                                  </template>
                                </el-table-column>-->
              </el-table>
              <!--              <div class="icon-container" @click="addCirculatRow()">-->
              <!--                &lt;!&ndash; 放置固定的图标 &ndash;&gt;-->
              <!--                <i class="el-icon-plus"></i>-->
              <!--              </div>-->
            </div>
          </div>
        </div>
        <div class="el-flexCirculationDialog el-border-bottom">
          <div style="width: 112px;text-align: center;font-weight: 600">
            问题描述
          </div>
          <div class="el-border-left acceptDate" style="height: 80px;width: 80%;">
            <el-form-item style="width: 100%;padding-left:20px;margin:0;">
              <el-input v-if="stepMarker=='csjcd_first'" type="textarea"
                        :rows="3" v-model="dataForm.checkOrder.problemDescription" placeholder="问题描述..."></el-input>
              <span v-else>{{ dataForm.checkOrder.problemDescription }}</span>
            </el-form-item>
          </div>
        </div>
        <div class="el-flexCirculationDialog el-border-bottom">
          <div style="width: 112px;text-align: center;font-weight: 600">
            问题处理
          </div>
          <div class="el-border-left acceptDate" style="height: 80px;width: 80%;">
            <el-form-item style="width: 100%;padding-left:20px;margin:0;">
              <el-input v-if="stepMarker=='csjcd_wtcl'" type="textarea"
                        :rows="3" v-model="dataForm.checkOrder.problemProcess" placeholder="问题处理..."></el-input>
              <span v-else>{{ dataForm.checkOrder.problemProcess }}</span>
            </el-form-item>
          </div>
        </div>
        <div class="el-flexCirculationDialog">
          <div style="width: 112px;text-align: center;font-weight: 600">
            处理人
          </div>
          <div class="el-border-left-right acceptDate1" style="width: 40%;height: 40px;">
            <el-form-item style="width: 100%;padding-left:20px;margin:0;">
              <span>{{ dataForm.checkOrder.processor }}</span>
            </el-form-item>
          </div>
          <div style="width: 84px;text-align: center;font-weight: 600">
            验证人
          </div>
          <div class="el-border-left acceptDate1" style="width: 40%;height: 40px;">
            <el-form-item label-width="150px" style="width: 100%;padding-left:20px;margin-bottom:0">
              <span>{{ dataForm.checkOrder.verifier }}</span>
            </el-form-item>
          </div>
        </div>
      </div>
    </el-form>
    <template v-slot:footer>
      <el-button v-if="dataForm.disabled" type="primary" @click="print()">打印</el-button>
    </template>
  </zt-dialog>
</template>

<script>
import qs from "qs";
import Cookies from "js-cookie";

export default {
  data() {
    return {
      pageCode: '',
      stepMarker: '',
      configDetailRow: null,
      subtitle: '',
      pageName: {
        plan: '软件测试计划', explain: '软件测试说明', record: '软件测试记录', report: '软件测试报告',
        contract: '合同评审阶段', require: '测试需求分析与策划阶段',execute:'测试设计与实现、执行阶段',summary:'测试总结阶段'
      },
      dataForm: {
        id: '',
        projectId: '',
        project: {
          softwareIdentity: '',
          softwareName: '',
        },
        checkOrder: {
          code: '',
          examiner: '',
          examDate: '',
          problemDescription: '',
          problemProcess: '',
          processor: '',
          verifier: '',
        },
        checkOrderList: []
      }
    }
  },
  computed: {
    getDict() {
      if (this.pageCode && (this.pageCode === 'plan' || this.pageCode === 'explain' || this.pageCode === 'record' || this.pageCode === 'report')) {
          return 'tristate1'
        } else {
          return 'tristate2'
        }
      }
  },
  methods: {
    init(id, row) {
      this.configDetailRow = row
      if (row.checkId) {
        console.log('配置项入库审核进来的 TestCheckOrder-AddOrUpdate.vue init row.checkId')
        if (row.checkId != -1) {
          this.dataForm.id = row.checkId
        }
      } else if (id) {
        this.dataForm.id = id
      } else {
        this.dataForm.id = row.id
      }
      this.pageCode = row.pageCode
      this.subtitle = this.pageName[this.pageCode]

      if (row.projectId) {
        this.dataForm.projectId = row.projectId
      }
      if (this.configDetailRow) {
        if (!row.stepMarker) {
          this.stepMarker = 'csjcd_first'
          this.title = '发起测试检查单'
        } else {
          this.title = row.stepName
          this.stepMarker = row.stepMarker
        }
      }
      //this.dataForm.disabled
      this.getInfo()

      //console.log(this.dataForm.id, this.dataForm.projectId, this.stepMarker, 'this.dataForm.id, this.dataForm.projectId,this.stepMarker')
    },
    indexFormat(index) {
      return index += 1
    },
    // 获取信息
    async getInfo() {
      let params = {
        checkId: this.dataForm.id,
        projectId: this.dataForm.projectId,
        pageCode: this.pageCode
      }
      console.log(this.pageCode, "getInfo pageCode")
      let res = await this.$http.get(`/testCheckOrder/TestCheckOrder/getDto`, {params: params})
      this.dataForm = {
        ...this.dataForm,
        ...res.data
      }
      console.log(this.dataForm, 'this.dataForm this.dataForm')
    },
    async print() {
      var params = qs.stringify({
        token: Cookies.get('token'),
        id: this.dataForm.id,
        pageCode: this.pageCode
      })
      let apiURL = `/testCheckOrder/TestCheckOrder/exportCheckOrder`
      window.location.href = `${window.SITE_CONFIG['apiURL']}${apiURL}?${params}`
    },
    // 表单提交
    async formSubmit(submitType) {
      let isFlow = false
      if (submitType == 'tj') {
        for (let item of this.dataForm.checkOrderList) {
          if (!item.checkResult) {
            this.$alert("有未填写的数据")
            return
          } else if (item.checkResult == "2") {
            isFlow = true
          }
        }
        if (submitType == 'tj' && !isFlow) {
          submitType == ''
        }
      }
      if (submitType == 'bl') {
        isFlow = true
      }
      if (submitType == 'tj' && isFlow || submitType == 'bl' && isFlow) {
        let flowInfo = {
          flowCode: 'csjcd',
          stepIdMark: this.stepMarker,
          submitType: submitType
        }
        this.dataForm.flowInfoDto = flowInfo;
      }
      console.log(this.dataForm, "this.dataForm formSubmit(submitType)")
      let res = await this.$http[!this.dataForm.id ? 'post' : 'put']('/testCheckOrder/TestCheckOrder/', this.dataForm)
      if (res.success) {
        await this.$tip.success()
        this.$refs.dialog.close()
        this.$emit('recall', res.data, this.configDetailRow)
        this.$emit('refreshDataList')
      }
    }
  }
}
</script>
<style>
.el-flexCirculationDialog {
  display: flex;
  align-items: center
}

.testCheckFormAuto .acceptDate > .el-form-item > .el-form-item__content {
  width: 100%;
}

.testCheckFormAuto .acceptDate1 > .el-form-item > .el-form-item__content {
  width: 100%;
}

.testCheckFormAuto .marginTopAndMarginBottom {
  margin-top: 10px !important;
  margin-bottom: 0 !important;
}

.testCheckFormAuto .marginTopAndMarginBottom2 {
  margin-top: -10px !important;
  margin-bottom: 10px !important;
}

.testCheckFormAuto .marginTopAndMarginBottom3 {
  margin-top: 0 !important;
  margin-bottom: 10px !important;
}

.testCheckFormAuto .acceptDate > .el-form-item > .el-form-item__content {
  line-height: 78px;
}

.testCheckContentWidth > .el-form-item > .el-form-item__content {
  width: calc(100% - 120px);
}

.testCheckFormAuto .el-radio {
  margin-right: 10px;
}
</style>
